import { svelte } from '@sveltejs/vite-plugin-svelte';
import rollupOptions from './rollup.config.mjs';

/**
 * @type {import('vite').UserConfig}
 */
const config = {
  plugins: [svelte()],
  base: '',
  build: {
    target: 'chrome91',
    outDir: 'frontend',
    rollupOptions,
  },
};

export default config;
