import { entityApi } from '../../../services/api';
import { EntityRepository, EntityRepositoryInterface } from '../entity-repository';

export const languageRepository: EntityRepositoryInterface<LanguageSerializedInterface, LangCode> =
  new EntityRepository((code) => entityApi.readLanguage(code));
