/**
 * This entity represents a single real-world entity, be it a person or named group of persons.
 */
interface AuthorInterface extends IdentifiableInterface, MultiNamedInterface {
  names: Promise<AuthorNameInterface[]> | number[];

  /**
   * ultimately connects the author with a work and their role in that work
   */
  workAuthors: Promise<WorkAuthorInterface[]> | number[];
}
