/**
 * This tag entity tags a character in a work.
 */
interface CharacterTagInterface extends IdentifiableInterface, WeightedInterface {
  /**
   * the character ina work this tag describes
   */
  workCharacter: Promise<WorkCharacterInterface> | number;

  /**
   * the describing tag
   */
  tag: Promise<TagInterface> | number;
}
