declare const enum IpcChannel {
  // functionality

  NHENTAI_SAVE_FAVORITES = 'NHENTAI_SAVE_FAVORITES',
  NHENTAI_GET_WORK = 'NHENTAI_GET_WORK',

  // entity CRUD

  ENTITY_CREATE_AUTHOR = 'ENTITY_CREATE_AUTHOR',
  ENTITY_CREATE_AUTHOR_NAME = 'ENTITY_CREATE_AUTHOR_NAME',
  ENTITY_CREATE_AUTHOR_ROLE = 'ENTITY_CREATE_AUTHOR_ROLE',
  ENTITY_CREATE_AUTHOR_ROLE_NAME = 'ENTITY_CREATE_AUTHOR_ROLE_NAME',
  ENTITY_CREATE_CHARACTER_TAG = 'ENTITY_CREATE_CHARACTER_TAG',
  ENTITY_CREATE_COLLECTION = 'ENTITY_CREATE_COLLECTION',
  ENTITY_CREATE_COLLECTION_NAME = 'ENTITY_CREATE_COLLECTION_NAME',
  ENTITY_CREATE_COLLECTION_PART = 'ENTITY_CREATE_COLLECTION_PART',
  ENTITY_CREATE_COPY = 'ENTITY_CREATE_COPY',
  ENTITY_CREATE_INTERACTION_TAG = 'ENTITY_CREATE_INTERACTION_TAG',
  ENTITY_CREATE_SITE = 'ENTITY_CREATE_SITE',
  ENTITY_CREATE_SITE_NAME = 'ENTITY_CREATE_SITE_NAME',
  ENTITY_CREATE_SOURCE = 'ENTITY_CREATE_SOURCE',
  ENTITY_CREATE_TAG = 'ENTITY_CREATE_TAG',
  ENTITY_CREATE_TAG_NAME = 'ENTITY_CREATE_TAG_NAME',
  ENTITY_CREATE_TRANSFORMATION = 'ENTITY_CREATE_TRANSFORMATION',
  ENTITY_CREATE_TRANSFORMATION_TYPE = 'ENTITY_CREATE_TRANSFORMATION_TYPE',
  ENTITY_CREATE_TRANSFORMATION_TYPE_NAME = 'ENTITY_CREATE_TRANSFORMATION_TYPE_NAME',
  ENTITY_CREATE_WORK_AUTHOR = 'ENTITY_CREATE_WORK_AUTHOR',
  ENTITY_CREATE_WORK_CHARACTER = 'ENTITY_CREATE_WORK_CHARACTER',
  ENTITY_CREATE_WORK_CHARACTER_NAME = 'ENTITY_CREATE_WORK_CHARACTER_NAME',
  ENTITY_CREATE_WORK = 'ENTITY_CREATE_WORK',
  ENTITY_CREATE_WORK_NAME = 'ENTITY_CREATE_WORK_NAME',
  ENTITY_CREATE_WORK_TAG = 'ENTITY_CREATE_WORK_TAG',
  ENTITY_CREATE_WORLD = 'ENTITY_CREATE_WORLD',
  ENTITY_CREATE_WORLD_NAME = 'ENTITY_CREATE_WORLD_NAME',
  ENTITY_CREATE_WORLD_CHARACTER = 'ENTITY_CREATE_WORLD_CHARACTER',
  ENTITY_CREATE_WORLD_CHARACTER_NAME = 'ENTITY_CREATE_WORLD_CHARACTER_NAME',

  ENTITY_READ_AUTHOR = 'ENTITY_READ_AUTHOR',
  ENTITY_READ_AUTHOR_NAME = 'ENTITY_READ_AUTHOR_NAME',
  ENTITY_READ_AUTHOR_ROLE = 'ENTITY_READ_AUTHOR_ROLE',
  ENTITY_READ_AUTHOR_ROLE_NAME = 'ENTITY_READ_AUTHOR_ROLE_NAME',
  ENTITY_READ_CHARACTER_TAG = 'ENTITY_READ_CHARACTER_TAG',
  ENTITY_READ_COLLECTION = 'ENTITY_READ_COLLECTION',
  ENTITY_READ_COLLECTION_NAME = 'ENTITY_READ_COLLECTION_NAME',
  ENTITY_READ_COLLECTION_PART = 'ENTITY_READ_COLLECTION_PART',
  ENTITY_READ_COPY = 'ENTITY_READ_COPY',
  ENTITY_READ_INTERACTION_TAG = 'ENTITY_READ_INTERACTION_TAG',
  ENTITY_READ_LANGUAGE = 'ENTITY_READ_LANGUAGE',
  ENTITY_READ_SITE = 'ENTITY_READ_SITE',
  ENTITY_READ_SITE_NAME = 'ENTITY_READ_SITE_NAME',
  ENTITY_READ_SOURCE = 'ENTITY_READ_SOURCE',
  ENTITY_READ_TAG = 'ENTITY_READ_TAG',
  ENTITY_READ_TAG_NAME = 'ENTITY_READ_TAG_NAME',
  ENTITY_READ_TRANSFORMATION = 'ENTITY_READ_TRANSFORMATION',
  ENTITY_READ_TRANSFORMATION_TYPE = 'ENTITY_READ_TRANSFORMATION_TYPE',
  ENTITY_READ_TRANSFORMATION_TYPE_NAME = 'ENTITY_READ_TRANSFORMATION_TYPE_NAME',
  ENTITY_READ_WORK_AUTHOR = 'ENTITY_READ_WORK_AUTHOR',
  ENTITY_READ_WORK_CHARACTER = 'ENTITY_READ_WORK_CHARACTER',
  ENTITY_READ_WORK_CHARACTER_NAME = 'ENTITY_READ_WORK_CHARACTER_NAME',
  ENTITY_READ_WORK = 'ENTITY_READ_WORK',
  ENTITY_READ_WORK_NAME = 'ENTITY_READ_WORK_NAME',
  ENTITY_READ_WORK_TAG = 'ENTITY_READ_WORK_TAG',
  ENTITY_READ_WORLD = 'ENTITY_READ_WORLD',
  ENTITY_READ_WORLD_NAME = 'ENTITY_READ_WORLD_NAME',
  ENTITY_READ_WORLD_CHARACTER = 'ENTITY_READ_WORLD_CHARACTER',
  ENTITY_READ_WORLD_CHARACTER_NAME = 'ENTITY_READ_WORLD_CHARACTER_NAME',

  ENTITY_UPDATE_AUTHOR = 'ENTITY_UPDATE_AUTHOR',
  ENTITY_UPDATE_AUTHOR_NAME = 'ENTITY_UPDATE_AUTHOR_NAME',
  ENTITY_UPDATE_AUTHOR_ROLE = 'ENTITY_UPDATE_AUTHOR_ROLE',
  ENTITY_UPDATE_AUTHOR_ROLE_NAME = 'ENTITY_UPDATE_AUTHOR_ROLE_NAME',
  ENTITY_UPDATE_CHARACTER_TAG = 'ENTITY_UPDATE_CHARACTER_TAG',
  ENTITY_UPDATE_COLLECTION = 'ENTITY_UPDATE_COLLECTION',
  ENTITY_UPDATE_COLLECTION_NAME = 'ENTITY_UPDATE_COLLECTION_NAME',
  ENTITY_UPDATE_COLLECTION_PART = 'ENTITY_UPDATE_COLLECTION_PART',
  ENTITY_UPDATE_COPY = 'ENTITY_UPDATE_COPY',
  ENTITY_UPDATE_INTERACTION_TAG = 'ENTITY_UPDATE_INTERACTION_TAG',
  ENTITY_UPDATE_SITE = 'ENTITY_UPDATE_SITE',
  ENTITY_UPDATE_SITE_NAME = 'ENTITY_UPDATE_SITE_NAME',
  ENTITY_UPDATE_SOURCE = 'ENTITY_UPDATE_SOURCE',
  ENTITY_UPDATE_TAG = 'ENTITY_UPDATE_TAG',
  ENTITY_UPDATE_TAG_NAME = 'ENTITY_UPDATE_TAG_NAME',
  ENTITY_UPDATE_TRANSFORMATION = 'ENTITY_UPDATE_TRANSFORMATION',
  ENTITY_UPDATE_TRANSFORMATION_TYPE = 'ENTITY_UPDATE_TRANSFORMATION_TYPE',
  ENTITY_UPDATE_TRANSFORMATION_TYPE_NAME = 'ENTITY_UPDATE_TRANSFORMATION_TYPE_NAME',
  ENTITY_UPDATE_WORK_AUTHOR = 'ENTITY_UPDATE_WORK_AUTHOR',
  ENTITY_UPDATE_WORK_CHARACTER = 'ENTITY_UPDATE_WORK_CHARACTER',
  ENTITY_UPDATE_WORK_CHARACTER_NAME = 'ENTITY_UPDATE_WORK_CHARACTER_NAME',
  ENTITY_UPDATE_WORK = 'ENTITY_UPDATE_WORK',
  ENTITY_UPDATE_WORK_NAME = 'ENTITY_UPDATE_WORK_NAME',
  ENTITY_UPDATE_WORK_TAG = 'ENTITY_UPDATE_WORK_TAG',
  ENTITY_UPDATE_WORLD = 'ENTITY_UPDATE_WORLD',
  ENTITY_UPDATE_WORLD_NAME = 'ENTITY_UPDATE_WORLD_NAME',
  ENTITY_UPDATE_WORLD_CHARACTER = 'ENTITY_UPDATE_WORLD_CHARACTER',
  ENTITY_UPDATE_WORLD_CHARACTER_NAME = 'ENTITY_UPDATE_WORLD_CHARACTER_NAME',

  ENTITY_DELETE_AUTHOR = 'ENTITY_DELETE_AUTHOR',
  ENTITY_DELETE_AUTHOR_NAME = 'ENTITY_DELETE_AUTHOR_NAME',
  ENTITY_DELETE_AUTHOR_ROLE = 'ENTITY_DELETE_AUTHOR_ROLE',
  ENTITY_DELETE_AUTHOR_ROLE_NAME = 'ENTITY_DELETE_AUTHOR_ROLE_NAME',
  ENTITY_DELETE_CHARACTER_TAG = 'ENTITY_DELETE_CHARACTER_TAG',
  ENTITY_DELETE_COLLECTION = 'ENTITY_DELETE_COLLECTION',
  ENTITY_DELETE_COLLECTION_NAME = 'ENTITY_DELETE_COLLECTION_NAME',
  ENTITY_DELETE_COLLECTION_PART = 'ENTITY_DELETE_COLLECTION_PART',
  ENTITY_DELETE_COPY = 'ENTITY_DELETE_COPY',
  ENTITY_DELETE_INTERACTION_TAG = 'ENTITY_DELETE_INTERACTION_TAG',
  ENTITY_DELETE_SITE = 'ENTITY_DELETE_SITE',
  ENTITY_DELETE_SITE_NAME = 'ENTITY_DELETE_SITE_NAME',
  ENTITY_DELETE_SOURCE = 'ENTITY_DELETE_SOURCE',
  ENTITY_DELETE_TAG = 'ENTITY_DELETE_TAG',
  ENTITY_DELETE_TAG_NAME = 'ENTITY_DELETE_TAG_NAME',
  ENTITY_DELETE_TRANSFORMATION = 'ENTITY_DELETE_TRANSFORMATION',
  ENTITY_DELETE_TRANSFORMATION_TYPE = 'ENTITY_DELETE_TRANSFORMATION_TYPE',
  ENTITY_DELETE_TRANSFORMATION_TYPE_NAME = 'ENTITY_DELETE_TRANSFORMATION_TYPE_NAME',
  ENTITY_DELETE_WORK_AUTHOR = 'ENTITY_DELETE_WORK_AUTHOR',
  ENTITY_DELETE_WORK_CHARACTER = 'ENTITY_DELETE_WORK_CHARACTER',
  ENTITY_DELETE_WORK_CHARACTER_NAME = 'ENTITY_DELETE_WORK_CHARACTER_NAME',
  ENTITY_DELETE_WORK = 'ENTITY_DELETE_WORK',
  ENTITY_DELETE_WORK_NAME = 'ENTITY_DELETE_WORK_NAME',
  ENTITY_DELETE_WORK_TAG = 'ENTITY_DELETE_WORK_TAG',
  ENTITY_DELETE_WORLD = 'ENTITY_DELETE_WORLD',
  ENTITY_DELETE_WORLD_NAME = 'ENTITY_DELETE_WORLD_NAME',
  ENTITY_DELETE_WORLD_CHARACTER = 'ENTITY_DELETE_WORLD_CHARACTER',
  ENTITY_DELETE_WORLD_CHARACTER_NAME = 'ENTITY_DELETE_WORLD_CHARACTER_NAME',
}
