import type { MigrationInterface, QueryRunner } from 'typeorm';

export class addLanguages1611508644004 implements MigrationInterface {
  public async up(queryRunner: QueryRunner): Promise<void> {
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.ABKHAZIAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.AFAR}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.AFRIKAANS}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.AKAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.ALBANIAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.AMHARIC}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.ARABIC}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.ARAGONESE}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.ARMENIAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.ASSAMESE}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.AVARIC}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.AVESTAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.AYMARA}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.AZERBAIJANI}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.BAMBARA}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.BASHKIR}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.BASQUE}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.BELARUSIAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.BENGALI}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.BIHARI_LANGUAGES}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.BISLAMA}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.BOSNIAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.BRETON}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.BULGARIAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.BURMESE}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.CATALAN_VALENCIAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.CHAMORRO}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.CHECHEN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.CHICHEWA_CHEWA_NYANJA}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.CHINESE}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.CHUVASH}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.CORNISH}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.CORSICAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.CREE}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.CROATIAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.CZECH}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.DANISH}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.DIVEHI_DHIVEHI_MALDIVIAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.DUTCH_FLEMISH}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.DZONGKHA}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.ENGLISH}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.ESPERANTO}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.ESTONIAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.EWE}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.FAROESE}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.FIJIAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.FINNISH}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.FRENCH}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.FULAH}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.GALICIAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.GEORGIAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.GERMAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.GREEK_MODERN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.GUARANI}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.GUJARATI}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.HAITIAN_HAITIAN_CREOLE}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.HAUSA}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.HEBREW}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.HERERO}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.HINDI}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.HIRI_MOTU}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.HUNGARIAN}')`);
    await queryRunner.query(
      `INSERT INTO language VALUES('${LangCode.INTERLINGUA_INTERNATIONAL_AUXILIARY_LANGUAGE_ASSOCIATION}')`,
    );
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.INDONESIAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.INTERLINGUE_OCCIDENTAL}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.IRISH}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.IGBO}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.INUPIAQ}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.IDO}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.ICELANDIC}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.ITALIAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.INUKTITUT}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.JAPANESE}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.JAVANESE}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.KALAALLISUT_GREENLANDIC}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.KANNADA}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.KANURI}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.KASHMIRI}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.KAZAKH}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.CENTRAL_KHMER}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.KIKUYU_GIKUYU}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.KINYARWANDA}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.KIRGHIZ_KYRGYZ}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.KOMI}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.KONGO}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.KOREAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.KURDISH}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.KUANYAMA_KWANYAMA}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.LATIN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.LUXEMBOURGISH_LETZEBURGESCH}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.GANDA}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.LIMBURGAN_LIMBURGER_LIMBURGISH}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.LINGALA}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.LAO}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.LITHUANIAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.LUBA_KATANGA}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.LATVIAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.MANX}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.MACEDONIAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.MALAGASY}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.MALAY}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.MALAYALAM}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.MALTESE}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.MAORI}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.MARATHI}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.MARSHALLESE}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.MONGOLIAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.NAURU}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.NAVAJO_NAVAHO}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.NORTH_NDEBELE}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.NEPALI}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.NDONGA}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.NORWEGIAN_BOKMAL}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.NORWEGIAN_NYNORSK}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.NORWEGIAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.SICHUAN_YI_NUOSU}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.SOUTH_NDEBELE}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.OCCITAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.OJIBWA}')`);
    await queryRunner.query(
      `INSERT INTO language VALUES('${LangCode.CHURCH_SLAVIC_OLD_SLAVONIC_CHURCH_SLAVONIC_OLD_BULGARIAN_OLD_CHURCH_SLAVONIC}')`,
    );
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.OROMO}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.ORIYA}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.OSSETIAN_OSSETIC}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.PUNJABI_PANJABI}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.PALI}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.PERSIAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.POLISH}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.PASHTO_PUSHTO}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.PORTUGUESE}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.QUECHUA}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.ROMANSH}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.RUNDI}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.ROMANIAN_MOLDAVIAN_MOLDOVAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.RUSSIAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.SANSKRIT}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.SARDINIAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.SINDHI}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.NORTHERN_SAMI}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.SAMOAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.SANGO}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.SERBIAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.GAELIC_SCOTTISH_GAELIC}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.SHONA}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.SINHALA_SINHALESE}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.SLOVAK}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.SLOVENIAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.SOMALI}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.SOUTHERN_SOTHO}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.SPANISH_CASTILIAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.SUNDANESE}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.SWAHILI}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.SWATI}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.SWEDISH}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.TAMIL}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.TELUGU}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.TAJIK}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.THAI}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.TIGRINYA}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.TIBETAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.TURKMEN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.TAGALOG}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.TSWANA}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.TONGA_TONGA_ISLANDS}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.TURKISH}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.TSONGA}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.TATAR}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.TWI}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.TAHITIAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.UIGHUR_UYGHUR}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.UKRAINIAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.URDU}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.UZBEK}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.VENDA}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.VIETNAMESE}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.VOLAPUK}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.WALLOON}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.WELSH}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.WOLOF}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.WESTERN_FRISIAN}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.XHOSA}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.YIDDISH}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.YORUBA}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.ZHUANG_CHUANG}')`);
    await queryRunner.query(`INSERT INTO language VALUES('${LangCode.ZULU}')`);
  }

  public async down(queryRunner: QueryRunner): Promise<void> {
    await queryRunner.clearTable('language');
  }
}
