import { BrowserWindow } from 'electron';

interface AppWindowInterface {
  window: BrowserWindow | null;

  /**
   * throws an Error when the window is null
   */
  getWindow(): BrowserWindow;

  open(): Promise<void>;

  close(force?: boolean): void;

  isClosed(): boolean;

  askForUserInteraction(): void;
}
