/**
 * This interface describes an object which can find works based on some identifying property.
 */
export interface SourceGetterInterface {
  /**
   * This method finds the work, deserializes it and all its relations into entities and persists them.
   * @returns the persisted work
   */
  find(identifier: string): Promise<WorkEntityInterface>;
}
