/**
 * This entity orders works in a collection.
 * The main use case is chronological ordering.
 */
interface CollectionPartInterface extends IdentifiableInterface, OrderableInterface {
  /**
   * the collection thw work is a part of
   */
  collection: Promise<CollectionInterface> | number;

  /**
   * the work inside the collection
   */
  work: Promise<WorkInterface> | number;
}
