/**
 * Entities implementing this interface build a hierarchy.
 */
interface HierarchicalInterface<T> {
  /**
   * parent entities
   */
  parents: Promise<T[]> | number[];

  /**
   * child entities
   */
  children: Promise<T[]> | number[];
}
