/**
 * Every database entity should implement this one.
 * It does nothing more but guarantee there is an id column.
 */
interface IdentifiableInterface<T extends Identifier = number> {
  /**
   * the entity id
   */
  readonly id: T;
}
