/**
 * This entity is non-user-maintained and describes a language.
 */
interface LanguageInterface extends IdentifiableInterface<LangCode> {
  /**
   * ISO 639-1 two-letter language code
   */
  readonly code: LangCode;

  /**
   * the works using this language
   */
  works: Promise<WorkInterface[]> | number[];
}
