/**
 * Entities extending this interface  can have multiple names.
 */
interface MultiNamedInterface extends IdentifiableInterface {
  /**
   * the name which is displayed in the user interface
   */
  nameCanonical: string;

  /**
   * other names for the entity
   */
  names: Promise<NameInterface[]> | number[];
}
