/**
 * This tag entity tags a work.
 */
interface WorkTagInterface extends IdentifiableInterface, WeightedInterface {
  /**
   * the describing tag
   */
  tag: Promise<TagInterface> | number;

  /**
   * the tagged work
   */
  work: Promise<WorkInterface> | number;
}
