interface WorkEntityInterface extends WorkInterface {
  names: Promise<WorkNameEntityInterface[]>;

  copies: Promise<CopyEntityInterface[]>;

  transformationOf: Promise<TransformationEntityInterface[]>;

  transformedBy: Promise<TransformationEntityInterface[]>;

  workAuthors: Promise<WorkAuthorEntityInterface[]>;

  workTags: Promise<WorkTagEntityInterface[]>;

  workCharacters: Promise<WorkCharacterEntityInterface[]>;

  worlds: Promise<WorldEntityInterface[]>;

  languages: Promise<LanguageEntityInterface[]>;

  collectionParts: Promise<CollectionPartEntityInterface[]>;
}
